/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package controldeasistencias.utils.mysql;

import controldeasistencias.Reportes.GenerarReportes;
import controldeasistencias.utils.Boot;
import controldeasistencias.utils.FuncionesUtiles;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.persistence.PersistenceException;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import org.apache.log4j.LogManager;

/**
 *
 * @author Administrador
 */
public class Respaldo extends javax.swing.JDialog {

    static Connection conn = null;

    static {
        // Cargamos el driver JDBC
        try {
            Class.forName("com.mysql.jdbc.Driver");
            System.out.println("Driver loaded...");
            org.apache.log4j.Logger log = LogManager.getLogger(GenerarReportes.class);
        } catch (ClassNotFoundException e) {
            System.out.println("MySQL JDBC Driver not found.");
            System.exit(1);
        }
        //Para iniciar el Logger.
        //inicializaLogger();
        try {
            //obtiene las propiedades de conexion desde un singleton
            String url = (String) Boot.getProperties().get(Boot.KEY_PARAM.keyURL);
            String user = (String) Boot.getProperties().get(Boot.KEY_PARAM.keyUser);
            String pass = (String) Boot.getProperties().get(Boot.KEY_PARAM.keyPass);
            //REALIZA LAS CONEXION CON LA BASE DE DATOS.
            conn = DriverManager.getConnection(url, user, pass);

            conn.setAutoCommit(false);
            System.out.println("Conexion establecida");
        } catch (SQLException e) {
            System.out.println("Error de conexión: " + e.getMessage());
            System.exit(4);
        }

    }

    File fichero;

    /**
     * Creates new form Respaldo
     */
    public Respaldo(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        pnlRestauracion.setVisible(false);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        jButton1 = new javax.swing.JButton();
        pnlRestauracion = new javax.swing.JPanel();
        txtFile = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jButton2 = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Respaldo"));

        jButton1.setText("GENERAR RESPLADO DE BASE DE DETOS");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap(84, Short.MAX_VALUE)
                .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 332, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(84, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jButton1)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pnlRestauracion.setBorder(javax.swing.BorderFactory.createTitledBorder("Restauración"));

        jLabel3.setText("Archivo:");

        jButton2.setText("RESTAURAR LA BASE DE DATOS");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });

        jButton3.setText("Buscar");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout pnlRestauracionLayout = new javax.swing.GroupLayout(pnlRestauracion);
        pnlRestauracion.setLayout(pnlRestauracionLayout);
        pnlRestauracionLayout.setHorizontalGroup(
            pnlRestauracionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlRestauracionLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlRestauracionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlRestauracionLayout.createSequentialGroup()
                        .addComponent(jLabel3)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(txtFile, javax.swing.GroupLayout.PREFERRED_SIZE, 336, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButton3))
                    .addComponent(jButton2, javax.swing.GroupLayout.PREFERRED_SIZE, 327, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(29, Short.MAX_VALUE))
        );
        pnlRestauracionLayout.setVerticalGroup(
            pnlRestauracionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlRestauracionLayout.createSequentialGroup()
                .addGap(50, 50, 50)
                .addGroup(pnlRestauracionLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(txtFile, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jButton3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 16, Short.MAX_VALUE)
                .addComponent(jButton2))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(pnlRestauracion, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(pnlRestauracion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        //obtiene las propiedades de conexion desde un singleton
        String url = (String) Boot.getProperties().get(Boot.KEY_PARAM.keyURL);
        String user = (String) Boot.getProperties().get(Boot.KEY_PARAM.keyUser);
        String pass = (String) Boot.getProperties().get(Boot.KEY_PARAM.keyPass);

        try {
            // TODO add your handling code here:
            Runtime runtime = Runtime.getRuntime();
            String command = "mysqldump --opt -p" + pass + ""
                    + " -u " + user + " personal -r respaldo-"
                    + FuncionesUtiles.getDateToBackUp(new Date()) + ".sql";
            System.out.println("Command>> " + command);

            Process child = runtime.exec(command);

            int processComplete = child.waitFor();

            if (processComplete == 0) {
                JOptionPane.showMessageDialog(this, "Se ha creado el respaldo.", "Mensaje", 1);
            } else {
                JOptionPane.showMessageDialog(this, "No se ha podido crear el respaldo.",
                        "Mensaje de error.", JOptionPane.ERROR_MESSAGE);
                // abnormally terminated, there was some problem
                //a way to read the error during the execution of the command
                InputStream errorStream = child.getErrorStream();
                byte[] buffer = new byte[errorStream.available()];
                errorStream.read(buffer);

                String str = new String(buffer);
                System.out.println(str);
            }

        } catch (IOException ex) {
            JOptionPane.showMessageDialog(this, "No se ha podido crear el respaldo.",
                    "Mensaje de error.", JOptionPane.ERROR_MESSAGE);
        } catch (InterruptedException ex) {
            Logger.getLogger(Respaldo.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        // TODO add your handling code here:
        JFileChooser fileChooser = new JFileChooser();
        fileChooser.setDialogTitle("Seleccione un archivo: ");
        int seleccion = fileChooser.showOpenDialog(null);

        if (seleccion == JFileChooser.APPROVE_OPTION) {
            fichero = fileChooser.getSelectedFile();
            // Aquí debemos abrir el fichero para escritura
            // y salvar nuestros datos.
            txtFile.setText(fichero.getAbsoluteFile().toString());
        }
    }//GEN-LAST:event_jButton3ActionPerformed

    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        // TODO add your handling code here:

        if (null != fichero) {
            try (BufferedReader br = new BufferedReader(new FileReader(fichero))) {
                Statement stmt = conn.createStatement();
                StringBuilder sb = new StringBuilder();
                String line = br.readLine();

                while (line != null) {
                    if (!line.contains("*/;")) {
                        sb.append(line);
                        sb.append(System.lineSeparator());
                        line = br.readLine();
                    }
                    line = br.readLine();
                }
                String everything = sb.toString();
                
//                if (true) {

                  if (stmt.execute(everything)) {

                    /*
                     StringTokenizer tokens = new StringTokenizer (everything, ";");
                     while (tokens.hasMoreTokens()) {
                    
                     }
                     */
                    JOptionPane.showMessageDialog(this, "Se ha restaurado la base de "
                            + "datos.", "Mensaje", 1);
                } else {
                    JOptionPane.showMessageDialog(this, "No se pudo restaurar la "
                            + "base de datos.", "Mensaje de error", JOptionPane.ERROR_MESSAGE);

                }

            } catch (IOException ex) {
                Logger.getLogger(Respaldo.class.getName()).log(Level.SEVERE, null, ex);
            } catch (PersistenceException pe) {
                pe.printStackTrace();
            } catch (SQLException ex) {
                Logger.getLogger(Respaldo.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }//GEN-LAST:event_jButton2ActionPerformed

    public static void main(String args[]) {
        new Respaldo(null, false).setVisible(true);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel pnlRestauracion;
    private javax.swing.JTextField txtFile;
    // End of variables declaration//GEN-END:variables
}
